/*
  Interface pour Boycott
 */


#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

#include "about.h"
#include "file_b.h"
#include "canvas.h"
#include "datas.h"
#include "gtkjoy.h"

#define TIMER_FREQMS	10


// les variables globales
GdkDrawable *canvas_pixmap;
GtkWidget *canvas;

int ptimer;

#define WIDTH     160
#define HEIGHT    144
#define MAXWIDTH  320
#define MAXHEIGHT 288

int x_size=WIDTH;
int y_size=HEIGHT;

extern int is_rom_charge;
extern unsigned char *GBBuffer;
extern int key[];
extern int FrameSkip;

char XKeys[256];


GdkImage    *gdkimage;
GtkWidget *window;

Display *display;

KeyCode KK_SPACE,KK_AVANT,KK_ARRIERE,KK_GAUCHE,KK_DROITE,KK_ENTREE,KK_A,KK_B,KK_QUIT;

int Control;


void clear_canvas(GtkWidget*, gpointer);


void pause_emulation();
void reset_emulation();
void quit_emulation();
void fskip_emulation(GtkWidget *,gint);
void control_emulation(GtkWidget *,gint);
void loadsnap_emulation();
void savesnap_emulation();
void normal_mode();
void scanline_mode();
void double_mode();
char TestKey(KeyCode touche);


// le joy
JoyData * joydata;
void joystick_events(gint etype, gint button, gpointer data);
GtkWidget *buttons[16];

void (*Transfert_from_GB_to_Image)(unsigned char*,int,int);

static GtkItemFactoryEntry menu_items[] = {
    {"/_File",NULL,NULL,0,"<Branch>"},
    {"/File/_Load ROM","<control>L",load_rom,0,NULL},
    {"/File/sep1",NULL,NULL,0,"<Separator>"},
    {"/File/_Pause Emulation","<control>P",pause_emulation,0,NULL},
    {"/File/_Reset Emulation","<control>R",reset_emulation,0,NULL},
    {"/File/sep2",NULL,NULL,0,"<Separator>"},
    {"/File/_Exit","<control>E",quit_emulation,0,NULL},

    {"/_Edit",NULL,NULL,0,"<Branch>"},
    {"/Edit/_Load Skin",NULL,NULL,0,NULL},
    {"/Edit/sep1",NULL,NULL,0,"<Separator>"},
    {"/Edit/_Save ScreenShot","F2",NULL,0,NULL},
    {"/Edit/sep2",NULL,NULL,0,"<Separator>"},
    {"/Edit/_Enter Debug Mode",NULL,NULL,0,NULL},

    {"/_Options",NULL,NULL,0,"<Branch>"},
    {"/Options/_Change Colors",NULL,NULL,0,NULL},
    {"/Options/_Load Colors",NULL,NULL,0,NULL},
    {"/Options/_Controls",NULL,NULL,0,"<Branch>"},
    {"/Options/Controls/Keyboard",NULL,control_emulation,0,"<RadioItem>"},
    {"/Options/Controls/Joystick",NULL,control_emulation,1,"/Options/Controls/Keyboard"},

    {"/_Video",NULL,NULL,0,"<Branch>"},
    {"/Video/_Mode video",NULL,NULL,0,"<Branch>"},
    {"/Video/Mode video/Normal",NULL,normal_mode,0,"<RadioItem>"},
    {"/Video/Mode video/Scanline",NULL,scanline_mode,0,"/Video/Mode video/Normal"},
    {"/Video/Mode video/Double",NULL,double_mode,0,"/Video/Mode video/Normal"},
    {"/Video/_Frame skip",NULL,NULL,0,"<Branch>"},
    {"/Video/Frame skip/0",NULL,fskip_emulation,0,"<RadioItem>"},
    {"/Video/Frame skip/1",NULL,fskip_emulation,1,"/Video/Frame skip/0"},
    {"/Video/Frame skip/2",NULL,fskip_emulation,2,"/Video/Frame skip/0"},
    {"/Video/Frame skip/3",NULL,fskip_emulation,3,"/Video/Frame skip/0"},
    {"/Video/Frame skip/5",NULL,fskip_emulation,5,"/Video/Frame skip/0"},
    {"/Video/Frame skip/10",NULL,fskip_emulation,10,"/Video/Frame skip/0"},
    {"/Video/_VSync",NULL,NULL,0,"<ToggleItem>"},

    {"/_Cheat",NULL,NULL,0,"<Branch>"},
    {"/Cheat/_Game Genie",NULL,NULL,0,NULL},
    {"/Cheat/sep1",NULL,NULL,0,"<Separator>"},
    {"/Cheat/_Load Snapshot",NULL,loadsnap_emulation,0,NULL},
    {"/Cheat/_Save Snapshot",NULL,savesnap_emulation,0,NULL},
    
    {"/_Help",NULL,NULL,0,"<LastBranch>"},
    {"/Help/_About",NULL,create_about_window,0,NULL}
};

void fskip_emulation(GtkWidget *widget,gint nb)
{
    FrameSkip = nb;    
}

void control_emulation(GtkWidget *widget,gint nb)
{
    Control = nb;
    
}


void normal_mode()
{
	clear_canvas(canvas, NULL);
    x_size = WIDTH;
    y_size = HEIGHT;
    Transfert_from_GB_to_Image=Transfert_from_GB_to_Image_Normal;    
}

void scanline_mode()
{
	clear_canvas(canvas, NULL);
    x_size = MAXWIDTH;
    y_size = MAXHEIGHT;
    Transfert_from_GB_to_Image=Transfert_from_GB_to_Image_Scanline;    
}

void double_mode()
{
	clear_canvas(canvas, NULL);
    x_size = MAXWIDTH;
    y_size = MAXHEIGHT;
    Transfert_from_GB_to_Image=Transfert_from_GB_to_Image_Double;    
}

void pause_emulation()
{
    key[K_PAUSE]=!key[K_PAUSE];
}

void reset_emulation()
{
    key[K_RESET]=1;
}

void quit_emulation()
{
    key[K_ESC]=1;
    if(is_rom_charge!=0)
        GB_Run();    
    gtk_main_quit();
}

void savesnap_emulation()
{
    key[K_SAVE_SNAP]=1;
}

void loadsnap_emulation()
{
    key[K_LOAD_SNAP]=1;
}



void get_main_menu(GtkWidget *window,GtkWidget **menubar)
{
    GtkItemFactory *item_factory;
    GtkAccelGroup *accel_group;
    gint n_menu_items=sizeof(menu_items)/sizeof(menu_items[0]);

    accel_group=gtk_accel_group_new();

    item_factory=gtk_item_factory_new(GTK_TYPE_MENU_BAR,"<main>",accel_group);

    gtk_item_factory_create_items(item_factory,n_menu_items,menu_items,NULL);

    gtk_accel_group_attach(accel_group,GTK_OBJECT(window));

    if(menubar){
        *menubar=gtk_item_factory_get_widget(item_factory,"<main>");
    }
}

void clear_canvas(GtkWidget *widget, gpointer data)
{
	GdkDrawable *drawable;
    GdkRectangle rect;
    drawable= widget->window;        
    Clear_Image(MAXWIDTH,MAXHEIGHT);    
    gdk_draw_image(drawable,widget->style->fg_gc[GTK_WIDGET_STATE(widget)],gdkimage,0,0,0,0,MAXWIDTH,MAXHEIGHT);
	rect.x=0;
	rect.y=0;
    rect.width= (widget->allocation.width>MAXWIDTH)?MAXWIDTH:widget->allocation.width;
    rect.height=(widget->allocation.height>MAXHEIGHT)?MAXHEIGHT:widget->allocation.height;
	gtk_widget_draw(widget, &rect);

}

void canvas_redraw(GtkWidget *widget, gpointer data)
{
	GdkDrawable *drawable;
    drawable= widget->window;        
    if(is_rom_charge!=0)
        Transfert_from_GB_to_Image(GBBuffer,WIDTH,HEIGHT);    
    gdk_draw_image(drawable,widget->style->fg_gc[GTK_WIDGET_STATE(widget)],gdkimage,0,0,0,0,x_size,y_size);    
}

void widget_redraw(GtkWidget *widget, gpointer data)
{
    GdkRectangle rect;
	rect.x=0;
	rect.y=0;
    rect.width= (widget->allocation.width>x_size)?x_size:widget->allocation.width;
    rect.height=(widget->allocation.height>y_size)?y_size:widget->allocation.height;
	gtk_widget_draw(widget, &rect);
}

int timer_events(gpointer data)
{
#ifdef EXPECT_BROKEN_TIMER
    gtk_timeout_remove(ptimer);
	ptimer=0;

	canvas_redraw(canvas, NULL);
	widget_redraw(canvas, NULL);

	ptimer = gtk_timeout_add(TIMER_FREQMS, timer_events, NULL);
#else

    gtk_timeout_remove(ptimer);
    ptimer=0;
    
        // lit le clavier
    if(!Control){
    XQueryKeymap(display,XKeys);
        
    key[K_LEFT]=TestKey(KK_GAUCHE);
    key[K_RIGHT]=TestKey(KK_DROITE);
    key[K_UP]=TestKey(KK_AVANT);
    key[K_DOWN]=TestKey(KK_ARRIERE);

    key[K_SPACE]=TestKey(KK_SPACE);
    key[K_ENTER]=TestKey(KK_ENTREE);
    key[K_CTRL]=TestKey(KK_A);
    key[K_ALT]=TestKey(KK_B);
    key[K_ESC]=TestKey(KK_QUIT);
    }
    
    
    if(is_rom_charge!=0) {        
        GB_Run();
    }
    
    canvas_redraw(canvas, NULL);
	widget_redraw(canvas, NULL);
    
    ptimer = gtk_timeout_add(TIMER_FREQMS, timer_events, NULL);
#endif
	
	return 1;
}









// Les evenements pour la fenetre principale
// si on tue la fenetre
void delete_event(GtkWidget *widget,GdkEvent *event,gpointer data)
{
    quit_emulation();
}



char TestKey(KeyCode test)
{
    return (XKeys[test>>3]&(1<<(test&7)));
}


int make_interface()
{
        // gestion clavier X11
    display=XOpenDisplay(NULL);
    KK_SPACE=XKeysymToKeycode(display,XK_space);
    KK_AVANT=XKeysymToKeycode(display,XK_Up);
    KK_ARRIERE=XKeysymToKeycode(display,XK_Down);
    KK_GAUCHE=XKeysymToKeycode(display,XK_Left);
    KK_DROITE=XKeysymToKeycode(display,XK_Right);
    KK_ENTREE=XKeysymToKeycode(display,XK_Return);
    KK_A=XKeysymToKeycode(display,XK_Control_L);
    KK_B=XKeysymToKeycode(display,XK_Alt_L);
    KK_QUIT=XKeysymToKeycode(display,XK_Q);

    
        // On cree la fenetre principale
    window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
        // on lui donne un titre
    gtk_window_set_title(GTK_WINDOW(window),BOYCOTT_NAME);
        // On lui connecte l evenement quit
    gtk_signal_connect(GTK_OBJECT(window), "delete_event",
                       GTK_SIGNAL_FUNC(delete_event),NULL);
 
        // on cree une vbox pour mettre le menu bar
    GtkWidget *vbox;
    vbox=gtk_vbox_new(FALSE,0);
    gtk_container_add (GTK_CONTAINER (window), vbox);

        // on cree le menu principal
    GtkWidget *menu_bar;
    get_main_menu(window,&menu_bar);
    gtk_box_pack_start(GTK_BOX(vbox),menu_bar,FALSE,TRUE,0);


        // on cree le widget graphique pour ecrire dedans
    canvas=create_canvas(MAXWIDTH,MAXHEIGHT);
    gdkimage=create_image(MAXWIDTH,MAXHEIGHT);

    Transfert_from_GB_to_Image=Transfert_from_GB_to_Image_Normal;    
    
    
        // on attache le canvas a la vbox
    gtk_box_pack_start(GTK_BOX(vbox),canvas,FALSE,TRUE,0);

    gtk_widget_realize (window);
    gtk_widget_realize (canvas);
    
        // on affiche tout
    gtk_widget_show_all (window);
    
    
}


void init_emulation()
{
    GB_Init();
    GB_Init_Palette();

}




int init_joystick(int argc, char *argv[])
{ /* open joystick device */
    if ( (argc > 1) && (argv[1][0] != '-') )
        joydata=joystick_new(argv[1], joystick_events, NULL);
    else
        joydata=joystick_new(NULL, joystick_events, NULL);
    
    if ( !joydata ) {
        g_print("Couldn't open joystick\n");
        return 0;
    }
    
}



void joystick_events(gint eventtype, gint button, gpointer data)
{
        // g_print("joystick_events\n");
        //g_print("joystick_events(%d, %d, %p)\n", eventtype, button, data);
/*
	 * if ( global.debugflag )
     *		
	 */

	/* we'll handle only buttons, 
	 * but type=2 (axis) could also be handled here */
/*	if ( ( (eventtype&3) == 1 ) &&
		 (button < JOYSTICK_MAXB ) )
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(buttons[button]),
        joydata->buttons[button]);*/

        // Les directions
    if(is_rom_charge==0)
        return;
    
    if((eventtype&2) == 2){
        switch(button){
            case 0:
                    //printf("axe x %d\n",joydata->axis[0]);
                if(joydata->axis[0]>(AXIS_MAX/2)){
                    key[K_RIGHT]=1;key[K_LEFT]=0;
                }
                else if(joydata->axis[0]<(-AXIS_MAX/2)){
                    key[K_LEFT]=1;key[K_RIGHT]=0;
                }
                else {
                    key[K_RIGHT]=0;key[K_LEFT]=0;
                }
                break;
            case 1:
                    //printf("axe y %d\n",joydata->axis[1]);
                if(joydata->axis[1]>(AXIS_MAX/2)){
                    key[K_DOWN]=1;key[K_UP]=0;
                }
                else if(joydata->axis[1]<(-AXIS_MAX/2)){
                    key[K_UP]=1;key[K_DOWN]=0;
                }
                else {
                    key[K_DOWN]=0;key[K_UP]=0;
                }
                break;
 
                break;
            default:
                break;
        }
    }
    
        // Les boutons
    if((eventtype&1) == 1){
        switch (button){
            case 0:
                key[K_CTRL]=!key[K_CTRL]; //printf("A\n");                
                break;
            case 1:
                key[K_ALT]=!key[K_ALT]; //printf("B\n");
                break;
            case 2:
                key[K_ENTER]=!key[K_ENTER]; //printf("ENTER\n");
                break;
            case 3:
                key[K_SPACE]=!key[K_SPACE]; //printf("SELECT\n");
                break;
            default:
                break;
        }
    }
    
    
}



int main(int argc, char *argv[])
{
        // On initialise gtk
    gtk_init(&argc,&argv);

        // on initialise un joystick
    init_joystick(argc,argv);
    

    
        // on cree l interface
    make_interface();

    ptimer = gtk_timeout_add(TIMER_FREQMS, timer_events, NULL);

        // On initialise le noyau emulation
    init_emulation();
    
        // la boucle d evenement
    gtk_main();
    XCloseDisplay(display);
    
    return 0;
    
}

